<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item :label="$t('表名称')" prop="tableName">
        <el-input
          v-model="queryParams.tableName"
          :placeholder="$t('请输入') + $t('表名称')"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item :label="$t('预警字段名称')" prop="fieldName">
        <el-input
          v-model="queryParams.fieldName"
          :placeholder="$t('请输入') + $t('预警字段名称')"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="cyan" icon="el-icon-search" size="mini" @click="handleQuery">{{ $t('搜索') }}</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">{{ $t('重置') }}</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="success"
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['system:alarmtype:edit']"
        >{{ $t('修改') }}</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['system:alarmtype:export']"
        >{{ $t('导出') }}</el-button>
      </el-col>
	  <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="alarmtypeList" @selection-change="handleSelectionChange" :height="clientHeight" border>
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column :label="$t('表名称')" align="center" prop="tableName" :show-overflow-tooltip="true"/>
      <el-table-column :label="$t('预警字段名称')" align="center" prop="fieldName" :show-overflow-tooltip="true"/>
      <el-table-column :label="$t('一级预警')" align="center" prop="firstlevel" :show-overflow-tooltip="true"/>
      <el-table-column :label="$t('二级预警')" align="center" prop="secondlevel" :show-overflow-tooltip="true"/>
      <el-table-column :label="$t('三级预警')" align="center" prop="thirdlevel" :show-overflow-tooltip="true"/>
      <el-table-column :label="$t('备注')" align="center" prop="remarks" width="300" :show-overflow-tooltip="true"/>
      <el-table-column :label="$t('启用状态')" align="center">
        <template slot-scope="scope">
          <el-switch
            v-model="scope.row.isOpen"
            :active-value="1"
            :inactive-value="0"
            @change="handleStatusChange(scope.row)"
          ></el-switch>
        </template>
      </el-table-column>
      <el-table-column :label="$t('操作')" align="center" fixed="right" width="230" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['system:alarmtype:edit']"
          >{{ $t('修改') }}</el-button>
          <!--<el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['system:alarmtype:remove']"
          >{{ $t('删除') }}</el-button>-->
          <el-button
            size="mini"
            type="text"
            icon="el-icon-message"
            @click="menuUpdate(scope.row)"
            v-hasPermi="['system:alarmtype:edit']"
          >{{ $t('负责人配置') }}</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改报警配置管理对话框 -->
    <el-dialog  :close-on-click-modal="false" v-dialogDrag :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item :label="$t('装置名称')" prop="plantCode">
          <el-select v-model="form.plantCode" :placeholder="$t('请选择') + $t('装置名称')">
            <el-option
              v-for="dict in plantCodeOptions"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item :label="$t('表名称')" prop="tableName">
          <el-input v-model="form.tableName" :placeholder="$t('请输入') + $t('表名称')" v-bind:disabled="diasabledInput" />
        </el-form-item>
        <el-form-item :label="$t('预警字段名称')" prop="fieldName">
          <el-input v-model="form.fieldName" :placeholder="$t('请输入') + $t('预警字段名称')" v-bind:disabled="diasabledInput" />
        </el-form-item>
        <el-form-item :label="$t('一级预警')" prop="firstlevel">
          <el-input v-model="form.firstlevel" :placeholder="$t('请输入') + $t('一级预警')" :disabled="isAble" />
        </el-form-item>
        <el-form-item :label="$t('二级预警')" prop="secondlevel">
          <el-input v-model="form.secondlevel" :placeholder="$t('请输入') + $t('二级预警')" :disabled="isAble" />
        </el-form-item>
        <el-form-item :label="$t('三级预警')" prop="thirdlevel">
          <el-input v-model="form.thirdlevel" :placeholder="$t('请输入') + $t('三级预警')" :disabled="isAble" />
        </el-form-item>
        <el-form-item :label="$t('备注')" prop="remarks">
          <el-input v-model="form.remarks" :placeholder="$t('请输入') + $t('备注')" />
        </el-form-item>
          <el-form-item :label="$t('归属部门')" prop="deptId">
              <treeselect v-model="form.deptId" :options="deptOptions" :show-count="true" :placeholder="$t('请选择') + $t('归属部门')" />
          </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">{{ $t('确 定') }}</el-button>
        <el-button @click="cancel">{{ $t('取 消') }}</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listAlarmtype, getAlarmtype, delAlarmtype, addAlarmtype, updateAlarmtype, exportAlarmtype, importTemplate, changeAlarmStatus} from "@/api/system/alarmtype";
import { treeselect } from "@/api/system/dept";
import { getToken } from "@/utils/auth";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";

export default {
  name: "Alarmtype",
  components: { Treeselect },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: false,
      // 总条数
      total: 0,
      // 报警配置管理表格数据
      alarmtypeList: [],
      // 弹出层标题
      title: "",
      // 部门树选项
      deptOptions: undefined,
      clientHeight:300,
      // 是否显示弹出层
      open: false,
      // 装置字典
      plantCodeOptions: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 20,
        tableName: null,
        fieldName: null,
      },
      //文本框是否可编辑
      diasabledInput: false,
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        plantCode: [
          { required: true, message: this.$t('装置') + this.$t('不能为空'), trigger: "change" }
        ],
      },
      //预警等级时间是否改
      isAble : false
    };
  },
  watch: {
    // 根据名称筛选部门树
    deptName(val) {
        this.$refs.tree.filter(val);
    }
   },
  created() {
      //设置表格高度对应屏幕高度
      this.$nextTick(() => {
          this.clientHeight = (document.body.clientHeight - 80) * 0.8
      })
    this.getList();
    this.getTreeselect();
    this.getDicts("PLANT_DIVIDE").then(response => {
      this.plantCodeOptions = response.data;
    });
  },
  methods: {
    /** 查询报警配置管理列表 */
    getList() {
      this.loading = true;
      listAlarmtype(this.queryParams).then(response => {
        this.alarmtypeList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
     /** 查询部门下拉树结构 */
     getTreeselect() {
          treeselect().then(response => {
              this.deptOptions = response.data;
          });
     },
    // 装置字典翻译
    plantCodeFormat(row, column) {
      return this.selectDictLabel(this.plantCodeOptions, row.plantCode);
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        plantCode: null,
        tableName: null,
        fieldName: null,
        firstlevel: null,
        secondlevel: null,
        thirdlevel: null,
        delFlag: null,
        createrCode: null,
        createdate: null,
        updaterCode: null,
        updatedate: null,
        deptId: null,
        remarks: null,
        isOpen: "0"
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    // 任务状态修改
    handleStatusChange(row) {
      //1为启用，0为停用
      let text = row.isOpen == "1" ? this.$t('启用') : this.$t('停用');
      this.$confirm(this.$t('确认要') + text + '"' + row.tableName + this.$t('"任务吗?'), this.$t('警告'), {
        confirmButtonText: this.$t('确定'),
        cancelButtonText: this.$t('取消'),
        type: "warning"
      }).then(function() {
        return changeAlarmStatus(row.id, row.isOpen);
      }).then(() => {
        this.msgSuccess(text + this.$t('成功'));
      }).catch(function() {
        row.isOpen = row.isOpen === "0" ? "1" : "0";
      });
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = this.$t('新增') + this.$t('空格') + this.$t('报警配置管理');
      this.diasabledInput=false;
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      this.diasabledInput=true;
      if (id === 1020 || id === 1061) {
        this.isAble = true
      }else {
        this.isAble = false
      }
      getAlarmtype(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = this.$t('修改') + this.$t('报警配置管理');
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateAlarmtype(this.form).then(response => {
              this.msgSuccess(this.$t('修改成功'));
              this.open = false;
              this.getList();
            });
          } else {
            addAlarmtype(this.form).then(response => {
              this.msgSuccess(this.$t('新增成功'));
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 负责人配置操作 */
    menuUpdate(row) {
      const tableId = row.id || this.ids[0];
      this.$router.push("/system/alarmprincipal/" + tableId);
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm(this.$t('是否确认删除?'), this.$t('警告'), {
          confirmButtonText: this.$t('确定'),
          cancelButtonText: this.$t('取消'),
          type: "warning"
        }).then(function() {
          return delAlarmtype(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess(this.$t('删除成功'));
        })
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm(this.$t('是否确认导出所有报警配置管理数据项?'), this.$t('警告'), {
          confirmButtonText: this.$t('确定'),
          cancelButtonText: this.$t('取消'),
          type: "warning"
        }).then(function() {
          return exportAlarmtype(queryParams);
        }).then(response => {
          this.download(response.msg);
        })
    },
  }
};
</script>
